/*
Парсинг советов с сайта fucking-great-advice.ru и вывод их на светодидную матрицу на базе Max7219. Платформа wemos di mini pro (ESP8266). 
В проекте были использованы материалы с сайта https://alexgyver.ru/. 
AMatroskin 2022
*/

#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Max72xxPanel.h>
#include <ArduinoJson.h>
#include <ESP8266WiFi.h>
#include "GyverButton.h"

#define BASE_PERIOD 600000                        //Период запроса нового совета (600000 мс = 10 минут)
#define BTN_PIN D2                                //Пин кнопки
#define PIN_CS D1                                 //Пин CS 
#define VERTICAL 1                                //Количество модулей в матрице по вертикали
#define HORIZONTAL 4                              //Количество модулей в матрице по горизонтали
#define WAIT 30                                   //задержка в миллисекундах для изменения скорости прокрутки (больше - медленние прокрутка)

const char* ssid     = "Имя Вашей WiFi сети";     //ssid WiFi
const char* password = "Пароль Вашей WiFi сети";  //Пароль WiFi

const char* host = "fucking-great-advice.ru";     //Источник мудрости
String raw_string = "";                           //Строка для парсинга данных
uint32_t tmr1, tmr2;                              //Переменные для работы таймеров
int string_count = 0;                             //Счетчик для работы прокрутки текста
byte wdt_count;
Max72xxPanel matrix = Max72xxPanel(PIN_CS, VERTICAL, HORIZONTAL);
GButton butt1(BTN_PIN);


String utf8rus(String source)                     // Перекодировать русские шрифты из UTF-8 в Windows-1251 
{
  int i, k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;
  while (i < k) {
    n = source[i]; i++;
    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
            n = source[i]; i++;
            if (n == 0x81) {
              n = 0xA8;
              break;
            }
            if (n >= 0x90 && n <= 0xBF) n = n + 0x2F;
            break;
          }
        case 0xD1: {
            n = source[i]; i++;
            if (n == 0x91) {
              n = 0xB7;
              break;
            }
            if (n >= 0x80 && n <= 0x8F) n = n + 0x6F;
            break;
          }
      }
    }
    m[0] = n; target = target + String(m);
  }
  return target;
}

void ICACHE_RAM_ATTR isr() {                      //Опрос кнопки в прерывании
  butt1.tick();
}

void setup() {
  pinMode (BTN_PIN, INPUT_PULLUP);
  attachInterrupt ( digitalPinToInterrupt (BTN_PIN), isr, CHANGE);
  Serial.begin(115200);
  delay(100);

  matrix.setIntensity(3);                         //Используйте значение между 0 и 15 для яркости
  matrix.setRotation(3);                          //развернуть строку 1 - 90, 2 - 180, 3 - 270
  delay(100);

  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);
  matrix.fillScreen(LOW);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    service_message ("Link");                     //Индикация установки соединения
    wdt_count ++;
    if (wdt_count > 21) while (1);                //Перезагрузка через софтверный WDT если не удалось подключиться втечение 10 секунд 
  }
  Serial.println();
  Serial.println("WiFi connected");
  service_message ("NetOK");                      //Есть соединение с сетью
  jsonGet();                                      //Запрашиваем первый совет

}
void loop() {
  butt1.tick();
  if (butt1.isClick()) {                           //При нажатии запрашиваем новые данные
    string_count = 0;
    jsonGet();
  }

  if (millis() - tmr1 >= BASE_PERIOD) {            //Запрашиваем новые данные через установленный интервал времени
    tmr1 = millis(); 
    string_count = 0;                                     
    jsonGet();
  }

  if (millis() - tmr2 >= WAIT) {                   //Вывод совета бегущей строкой с установленной скоростью (задержкой)
    tmr2 = millis();                                      
    output_on_display (raw_string);
  }
}

void output_on_display (String out_text) {         //Вовод совета бегущей строкой 
  int spacer = 2;                                  // Промежуток между символами (кол-во точек)
  int width = 5 + spacer;                          // Ширина шрифта 5 пикселей

  if (string_count < width * out_text.length() + matrix.width() - 1 - spacer)
  {
    ++string_count;
    matrix.fillScreen(LOW);

    int letter = string_count / width;                // номер символа выводимого на матрицу
    int x = (matrix.width() - 1) - string_count % width;
    int y = (matrix.height() - 8) / 2;                // отцентрировать текст по вертикали

    while ( x + width - spacer >= 0 && letter >= 0 ) {
      if ( letter < out_text.length() ) {
        matrix.drawChar(x, y, out_text[letter], HIGH, LOW, 1);
      }
      letter--;
      x -= width;
    }
    matrix.write();                                   // Отправить картинку для отображения
    if (string_count >= (width * out_text.length() + matrix.width() - 1 - spacer)) string_count = 0;
  }
}

void service_message (String text) {               //Функция для отображения на матрице сервисных сообщений
  matrix.fillScreen(LOW);
  for (int i = 0; i < text.length(); ++i) {
    matrix.drawChar((6 * i), 0, text[i], HIGH, LOW, 1);
    matrix.write();
  }
}


void jsonGet() {                                  // Запрос и разбор json 
  WiFiClient client;
  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {          //Если сайт не отвечает, сообщаем об этом
    Serial.println("connection failed");
    service_message ("NoRes");
    delay (3000);
    return;
  }
  client.println("GET http://fucking-great-advice.ru/api/random"); //GET запрос
  client.println("Host: fucking-great-advice.ru");
  client.println("Connection: close");
  client.println();

  delay(1500);

  while (client.available()) {
    raw_string = client.readStringUntil('\r');
  }

  StaticJsonDocument<512>  doc;                                  //Библитека ArduinoJson версии 6+
  DeserializationError error = deserializeJson(doc, raw_string); //десереализация из raw_string в doc
  if (error) {
    Serial.print(F("deserializeJson() failed: "));
    Serial.println(error.f_str());
    return;
  }

  String  sovet = doc["text"];                                  //Символы "—", "«", "»",отображаются некорректно, поэтому заменяем их если они есть. 
  sovet.replace("—", "-");
  sovet.replace("«", R"(")");
  sovet.replace("»", R"(")");
  
//____________Цензура, удалить или закомментировать для полноценной работы))))
//  sovet.replace("блять", "блин");
//  sovet.replace("бля", "блин");
//  sovet.replace("Бля", "блин");
//  sovet.replace("хуй", "***");
//  sovet.replace("Хуй", "***");
//  sovet.replace("Хуя", "**");
//  sovet.replace("ёб", "**");
//  sovet.replace("хуя", "***");
//  sovet.replace("пизд", "****");
//  sovet.replace("ёпта", "блин");
//  sovet.replace("ебать", "***");
  
  raw_string = utf8rus(sovet);
  Serial.println(sovet);
}
